import { Resource, StringName, Variant } from 'godot'
import { export_, export_enum, export_multiline } from 'godot.annotations'

enum ItemType {
  None,
  Key
}

export default class ItemData extends Resource {
  @export_(Variant.Type.TYPE_STRING_NAME)
  readonly name: StringName = ''

  @export_enum(ItemType)
  readonly type: ItemType = ItemType.None

  @export_multiline()
  readonly description: string = ''

  @export_(Variant.Type.TYPE_INT)
  readonly max_quantity: number = 99
}

